#ifndef UTILITARY_H
#define UTILITARY_H

#include<vector>
#include <random>
#include <time.h>
#include <chrono>

//--------------------------------------------------UTILITARY

//typedef
typedef unsigned int                        IdAgent;
typedef unsigned int                        IdGroup;

//g_uniform(g_m_t_generator) return a double between 0 and 1. (initialization in utility.cpp)
extern std::mt19937 g_m_t_generator;
extern std::uint32_t seed;

//--------------------------------------------------TEMPLATE VECTOR

template<int D, typename T>
struct NVector : public std::vector<NVector<D - 1, T>> {
  static_assert(D >= 1, "Vector dimension must be greater than zero!");
  template<typename... Args>
  NVector(int n = 0, Args... args) : std::vector<NVector<D - 1, T>>(n, NVector<D - 1, T>(args...)) {
  }
};

template<typename T>
struct NVector<1, T> : public std::vector<T> {
  NVector(int n = 0, const T& val = T()) : std::vector<T>(n, val) {
  }
};

#endif // UTILITARY_H
